﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Cheese : MonoBehaviour 
{
    //自分自身が持たれているか
    bool isTaken = false;

    /// <summary>
    /// 自分自身が持たれているかどうか
    /// </summary>
    public bool IsTaken
    {
        get
        {
            return isTaken;
        }
    }

    //箱に入ったかどうか
    bool isInBox = false;
    /// <summary>
    /// 箱に入っているかどうか
    /// </summary>
    public bool IsInBox
    {
        get
        {
            return isInBox;
        }
        set
        {
            isInBox = value;
        }
    }

    //自分自身のトランスフォーム
    Transform ownTrans;

    //プレイヤー（鼠）のトランスフォーム
    private Transform playerTrans = null;

    //プレイヤーからどのくらい離して追従させるか
    [SerializeField]
    Vector3 offset = new Vector3(0,0.5f, 0);

    //スタート時のY座標
    float startPosY;

    /// <summary>
    /// 初期のY座標（ワールド）
    /// </summary>
    public float StartPosY
    {
        get
        {
            return startPosY;
        }
    }
    

	// Use this for initialization
	void Start () 
    {
        ownTrans = GetComponent<Transform>();
        startPosY = ownTrans.position.y;
	}
	
	// Update is called once per frame
	void Update ()
    {
		if(isTaken)
        {
            if (playerTrans)
            {
                ownTrans.position = playerTrans.position + offset;
                ownTrans.rotation = playerTrans.rotation;
            }
        }
	}

    /// <summary>
    /// 自分自身が持たれる際に呼ばれる
    /// </summary>
    /// <param name="playerTrans">このチーズをもつ人のトランスフォーム</param>
    public void Take(Transform playerTrans)
    {
        isTaken = true;

        this.playerTrans = playerTrans;
    }

    /// <summary>
    ///  プレイヤーに置かれる処理
    /// </summary>
    /// <param name="putPos">置く場所</param>
    public void Put(Vector3 putPos)
    {
        isTaken = false;

        this.playerTrans = null;

        ownTrans.position = putPos;
    }
}
