using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TimeManager : MonoBehaviour {


	// Use Client Timer.
	int timer;
    int timerFrame;

    // Fixed value(Use frame per second)
    const int fps = 60;

	// Time limit value.
	const int timeLimit = 5;

    // Use Photon Server process. 
	[SerializeField]
	PhotonView MyPhotonView;


	// Use this for initialization.
	void Start () 
	{

        MyPhotonView.RPC("SyncTimer", PhotonTargets.All, timeLimit);

	}
	
	// Update is called once per frame.
	void Update () 
	{

        // Timer count down fixed fps.
        if (timerFrame % fps==0)
        {
            timer--;
        }

        timerFrame++;

	}

	// Use OtherObject Know timerCount.
	public int RemainingTimer()
	{

		return timer;

	}

	// Use otherClient syncTimer.
	[PunRPC]
	void SyncTimer ( int value ) 
	{

        timer = value;

	}



}
